/**************************************************************
**
**         C SWING  v 3.1   31-JUL-1989 09:09:57.32
**         =========================================
**
**         Author    :  S.J.Brown
**
**         Copyright :  Public Domain
**
**         File      :  SWING_36.C
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 2.4
**
**         VMS Ver.  :  5.1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date        Change                          Initials
**         ----------------------------------------------------
**         31-JUL-1989 Initial Version v3.0               SJB
**
**************************************************************/
 
/*
**  directory statistics
*/
#include <stdio.h>
#include <ssdef.h>
#include <smgdef.h>
#include <smgmsg.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

#define READING_INTERVAL	25

#define TOTAL_FILES		1
#define BLOCKS_ALLOCATED	2
#define BLOCKS_USED		3
#define FRAG_INDEX		4
#define BIGGEST_FILE		5
#define SHOW_NAMES		6
#define NEW_DATA		7

static int statistics_key;

dir_stats(n)
NODE *n;
{
    int status,input,previous;
    char prompt[SCREEN_WIDTH+1];

    /*
    **  show selected dirs highlighted
    */
    show_deleting(curr_l_ptr->n_ptr[current_level],
                  DELETING_RENDITION,
      		  FALSE);

    /*
    **  check twice with the user that he wishes to do this
    */
    if (confirm_user("Display statistics for these directories Y/N [N] ?","Y"))
    {
	title(STITLE);
 
        show_deleting(curr_l_ptr->n_ptr[current_level],
                      NORMAL_RENDITION,
      	    	      FALSE);

        render(current_line,current_level,SPECIAL_RENDITION);

        /*
        **  assign a channel (dir_channel) to this device as required
        **  by get_dir_files()
        */
        dir_channel = 0;
        status = sys$assign(DSC1("SYS$DISK"),
                            &dir_channel,
                            0,
                            0);
        if (status != SS$_NORMAL)
            panic(status,
                  "sys$assign",
                  "directory statistics");
	
	if (statistics_key)
        {
	    input = statistics_key;
	    if (confirm_user("Re-construct any existing statistical information Y/N [N] ? ","Y"))
	        show_statistics(n,0,NEW_DATA);
        }
	else
            input = SMG$K_TRM_UPPERCASE_C;

	previous = input;

        while(1)
	{
	    if (input == SMG$K_TRM_QUESTION_MARK)
		input = stats_menu();

	    switch(input)
	    {
case SMG$K_TRM_UPPERCASE_O:
case SMG$K_TRM_LOWERCASE_O:
		show_broadcasts();
		break;

case SMG$K_TRM_EXCLAMATION_POINT:
	        set_default(n->dir_name);
		set_init_position();
		refresh_display();
		message_set = 1;
		message("");
		strcpy(junk,"Statistics already enabled. To display statistics for ");
		strcat(junk,"a new sub-structure you must first of all quit from ");
		strcat(junk,"this option (Q to quit), then select the new node ");
		strcat(junk,"for the start of the statistics display.\r\n");
		strcat(junk,"PRESS ANY KEY TO CONTINUE");
		message(junk);
		ding(displayb);
		message_set = 0;
		get_key(NO_AUTO);
		message_set = 1;
		break;

case SMG$K_TRM_CTRLJ:
case SMG$K_TRM_UP:
 	        go_up();
                break;

case SMG$K_TRM_CTRLH:
case SMG$K_TRM_LEFT:
	        go_left();
                break;

case SMG$K_TRM_CTRLK:
case SMG$K_TRM_DOWN:
	        go_down();
                break;

case SMG$K_TRM_CTRLL:
case SMG$K_TRM_RIGHT:
	        go_right();
                break;

case SMG$K_TRM_UPPERCASE_N :
case SMG$K_TRM_LOWERCASE_N :
case SMG$K_TRM_NEXT_SCREEN :
	        go_next();
                break;

case SMG$K_TRM_UPPERCASE_B :
case SMG$K_TRM_LOWERCASE_B :
	        go_bottom();
                break;

case SMG$K_TRM_PREV_SCREEN :
case SMG$K_TRM_UPPERCASE_P :
case SMG$K_TRM_LOWERCASE_P :
	        go_prev();
                break;

case SMG$K_TRM_UPPERCASE_T :
case SMG$K_TRM_LOWERCASE_T :
	        go_top();
                break;

case SMG$K_TRM_UPPERCASE_G :
case SMG$K_TRM_LOWERCASE_G :
		grand_total(n,0);
		break;

case SMG$K_TRM_UPPERCASE_L :
case SMG$K_TRM_LOWERCASE_L :
                if (confirm_user("Two options, N for a narrow listing, W for a wide listing [Narrow] ?","W"))
                    create_listing(TRUE, TRUE);
                else
                    create_listing(FALSE, TRUE);
		break;

case SMG$K_TRM_UPPERCASE_C :
case SMG$K_TRM_LOWERCASE_C :
		previous = input;
		statistics_key = input;
		strcpy(prompt,"Displaying file count");
		show_statistics(n,0,TOTAL_FILES);
		break;

case SMG$K_TRM_UPPERCASE_A :
case SMG$K_TRM_LOWERCASE_A :
		previous = input;
		statistics_key = input;
		strcpy(prompt,"Displaying total blocks allocated");		
		show_statistics(n,0,BLOCKS_ALLOCATED);
		break;

case SMG$K_TRM_UPPERCASE_U :
case SMG$K_TRM_LOWERCASE_U :
		previous = input;
		statistics_key = input;
		strcpy(prompt,"Displaying total blocks used");	
		show_statistics(n,0,BLOCKS_USED);
		break;
	
case SMG$K_TRM_EQUAL:
		message_set = 1;
		message("");
		curr_l_ptr->n_ptr[current_level]->in_or_ex_clude = INCLUDE_FILES;
                if (!get_new_dir_spec(curr_l_ptr->n_ptr[current_level]))
		    break;

case SMG$K_TRM_NUMBER_SIGN:
		message_set = 1;
		message("");
		curr_l_ptr->n_ptr[current_level]->in_or_ex_clude = EXCLUDE_FILES;
                if (!get_new_dir_spec(curr_l_ptr->n_ptr[current_level]))
		    break;

case SMG$K_TRM_UPPERCASE_F :
case SMG$K_TRM_LOWERCASE_F :
		/*
		**  swing_files will assign up dir-channel,
		**  so we'll de-assign it first, otherwise
		**  we'll loose a channel
		*/
	        sys$dassgn(dir_channel);

		/*
		**  now call swing files
		*/
                swing_files(curr_l_ptr->n_ptr[current_level],
                            curr_l_ptr->n_ptr[current_level]->last_filename,
                            SHOW_FILES);
	        if (total_files == 0)
		    strcpy(curr_l_ptr->n_ptr[current_level]->dir_spec,
                           DEFAULT_DIR_SPEC);

		/*
		**  repair the title
		*/
		title(STITLE);

		/*
		**  assign the channel again
		*/
                dir_channel = 0;
                status = sys$assign(DSC1("SYS$DISK"),
                                    &dir_channel,
                                    0,
                                    0);
                if (status != SS$_NORMAL)
                    panic(status,
                          "sys$assign",
                          "directory statistics");
	
		break;

case SMG$K_TRM_UPPERCASE_I :
case SMG$K_TRM_LOWERCASE_I :
		previous = input;
		statistics_key = input;
		strcpy(prompt,"Displaying fragmentation index");
		show_statistics(n,0,FRAG_INDEX);
		break;

case SMG$K_TRM_UPPERCASE_M :
case SMG$K_TRM_LOWERCASE_M :
		previous = input;
		statistics_key = input;
		strcpy(prompt,"Displaying maximum file size");
		show_statistics(n,0,BIGGEST_FILE);
		break;

case SMG$K_TRM_UPPERCASE_D :
case SMG$K_TRM_LOWERCASE_D :
		previous = input;
		statistics_key = input;
		strcpy(prompt,"Displaying directory names");
		show_statistics(n,0,SHOW_NAMES);
		break;

case SMG$K_TRM_UPPERCASE_S :
case SMG$K_TRM_LOWERCASE_S :
		if (confirm_user("Re-construct the statistical information Y/N [N] ? ","Y"))
		    show_statistics(n,0,NEW_DATA);
		break;

case SMG$K_TRM_UPPERCASE_Q :
case SMG$K_TRM_LOWERCASE_Q :
		show_statistics(n,0,SHOW_NAMES);
		goto way_out;
		break;

case FALSE:
		break;

default:
		ding(displayb);
	        break;
	    }
 
            if (input == SMG$K_TRM_UPPERCASE_S ||
		input == SMG$K_TRM_LOWERCASE_S)
	    {
                input = previous;
		continue;
	    }

	    sprintf(junk,"%s - statistics option [? for menu] ",prompt);
	    message(junk);
	    message_set = 0;

	    set_default(curr_l_ptr->n_ptr[current_level]->dir_name);
	    sub_title_underline(curr_l_ptr->n_ptr[current_level]->dir_name);

	    input = get_key(NO_AUTO);
	}

    way_out:;
        sys$dassgn(dir_channel);

        render(current_line,current_level,SPECIAL_RENDITION);

	message_set = 1;
	message("");

	title(MTITLE);
    }
    else
    {
        show_deleting(curr_l_ptr->n_ptr[current_level],
                      NORMAL_RENDITION,
	    	      FALSE);
        render(current_line,current_level,SPECIAL_RENDITION);
    }
}

/*
**  show statistics
*/
show_statistics(n,level,option)
NODE *n;
int level;
int option;
{
    char tmp[SPEC_SIZE+1];
    float f;

    /*
    **  generate stats if not yet done so for this directory
    */
    if (option == NEW_DATA ||
        !n->stats_collected)
	generate_statistics(n);

    switch(option)
    {
case TOTAL_FILES:
        sprintf(tmp,"C %d",n->stats_total_files);
	break;

case BIGGEST_FILE:
	sprintf(tmp,"M %d",n->stats_biggest_file);
	break;

case BLOCKS_ALLOCATED:
        sprintf(tmp,"A %d",n->stats_total_size_alloc);
	break;

case BLOCKS_USED:
        sprintf(tmp,"U %d",n->stats_total_size_used);
	break;

case FRAG_INDEX:
        f = n->stats_total_pointers;
        if (n->stats_non_zero_files)
            f = f / n->stats_non_zero_files;	
	else
	    f = 0;
        sprintf(tmp,"I %5.2f",f);
	break;

case SHOW_NAMES:
	strcpy(tmp,n->name);
	break;

case NEW_DATA:
	goto to_children;
    }

    /*
    **  new short name
    */
    new_short_name(n,tmp);

to_children:;
    /*
    **  children
    */
    if (n->child)
        show_statistics(n->child,level+1,option);

    /*
    **  we don't look for sisters of the first node that we search
    */
    if (level && n->sister)
        show_statistics(n->sister,level,option);

    /*
    **  redo display if need be
    */
    if (level == 0 && option != NEW_DATA)
        refresh_display();
}
	
/*
**  generate statistics
*/
generate_statistics(n)
NODE *n;
{
    FILER *tmp;

    /*
    **  get all the files in this dir
    */
    files_selected = 0;
    first_file_ptr = curr_file_ptr = 0;
    total_files = 0;
    n->stats_non_zero_files = 0;
    n->stats_total_files = 0;
    n->stats_total_size_alloc = 0;
    n->stats_total_size_used = 0;
    n->stats_biggest_file = 0;
    n->stats_total_pointers = 0;
    
    sprintf(junk,"Searching %s",n->dir_name);
    message(junk);

    get_dir_files(n,SHOW_FILES_AND_DIRS);

    if (total_files)
    {
        /*
        **  get the directory information
        */
        tmp = first_file_ptr;
        while(tmp)
        {
	    if ((n->stats_total_files >= READING_INTERVAL) &&
	        (n->stats_total_files % READING_INTERVAL) == 0)
	    {
                sprintf(junk,
                        "Searching %s %d/%d",
                        n->dir_name,
                        n->stats_total_files,
                        total_files);
                message(junk);
	    }

	    tmp->rendition = TRUE;
            get_dir_info(tmp);
	    n->stats_total_files++;
	    n->stats_total_size_alloc += tmp->allocation;
	    if (tmp->allocation)
		n->stats_non_zero_files++;

	    n->stats_total_size_used += tmp->size;
	    if (tmp->allocation > n->stats_biggest_file)
		n->stats_biggest_file = tmp->allocation;
            n->stats_total_pointers += tmp->fragments;
	    tmp = tmp->forw_ptr;
	}

	/*
	**  free them off
	*/
	free_files(first_file_ptr);
    }

    n->stats_collected = 1;

    return(TRUE);
}

/*
**  calculate grand total info, display as message
*/
static int grand_alloc, grand_used, grand_non_zero_files;
static int grand_pointers, grand_files, grand_max;

grand_total(n,level)
NODE *n;
int level;
{
    float f;

    if (level == 0)
    {
	/*
	**  initialise totals
	*/
        grand_alloc = grand_used = grand_pointers = 
	grand_files = grand_max = grand_non_zero_files = 0;
    }

    grand_alloc    += n->stats_total_size_alloc;
    grand_used     += n->stats_total_size_used;
    grand_files    += n->stats_total_files;
    grand_non_zero_files += n->stats_non_zero_files;
    grand_pointers += n->stats_total_pointers;
    if (n->stats_biggest_file > grand_max)
        grand_max = n->stats_biggest_file;

    /*
    ** children
    */
    if (n->child)
        grand_total(n->child,level+1);

    /*
    **  we don't look for sisters of the first node that we add up
    */
    if (level && n->sister)
        grand_total(n->sister,level);

    if (level == 0)
    {
	/*
	**  tell user what we've found
        */
        f = grand_pointers;
        if (grand_non_zero_files)
            f = f / grand_non_zero_files;	
	else
	    f = 0;

	sprintf(junk,
		"STATISTICS GRAND TOTALS:\r\nfile count = %d,   ",
		grand_files);
	sprintf(_STR(junk),
		"maximum file size = %d blocks,\r\n",
		grand_max);
        sprintf(_STR(junk),
		"blocks allocated = %d,   blocks used = %d,\r\n",
		grand_alloc,
		grand_used);
	sprintf(_STR(junk),
		"fragmentation index = %.2f\r\nPRESS ANY KEY TO CONTINUE",
		f);

	message_set = 1;
	message("");
	message(junk);
	message_set = 0;
	get_key(NO_AUTO);
	message_set = 1;
    }
}
