/**************************************************************
**
**         C SWING  v 3.2.1   8-MAY-1990 20:38:44
**         =========================================
**
**         Author    :  M.Akerberg (mats@efd.lth.se)
**
**         Copyright :  Public Domain
**
**         File      :  SWING_38.C
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 3.2-044
**
**         VMS Ver.  :  5.4-1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date         Change                          Initials
**         -----------------------------------------------------
**          8-MAY-1990  Initial Version v3.2               MA
**         24-Jun-1991  Changed from More to MOST          MA
**         10-Oct-1992  Added ability to MOST a series
**                      of selected files for use with
**                      windows, to use MOST_SWITCHES
**                      and MOST_EDITOR if defined, to
**                      spawn if not captive, and to use
**                      all other functions in MOST        FM
**
**************************************************************/

/*
**  swing_38
**
**  type/most routines
*/
#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <ssdef.h>
#include <smgdef.h>
#include <trmdef.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

/*
**  type the current file or selected files via most
*/
most_files(n)
NODE *n;
{
    FILER *tmp;
    char *most_args[500];
    int num_most_args = 0;
    int screen;

    /*
    **  initial set of most_args[] could receive most's switches (-bcklstvw)
    **  and extended_switches (+d, +linenumber, +/string),
    **  so these lines are here as an example,
    **  but we don't use them.
    **
    most_args[num_most_args] = (char *) malloc(strlen("-csv")+1);
    strcpy(most_args[num_most_args++],"-csv");
    most_args[num_most_args] = (char *) malloc(strlen("+d")+1);
    strcpy(most_args[num_most_args++],"+d");
    */

    if (!files_selected)
    {
        /*
        **  most the current file
        */
        if (access(curr_file_ptr->filename,0) == 0)
        {
            tmp = current_file_ptr(curr_file_no);
            most_args[num_most_args] = (char *) malloc(strlen(tmp->filename)+1);
            strcpy(most_args[num_most_args++],tmp->filename);
        }
        else
        {
            sprintf(junk,"%s is not accessable",curr_file_ptr->filename);
            warning(junk);
            return(FALSE);
        }
    }
    else
    {
        /*
        **  confirm intention to most the selected files
        */
        if (files_selected == 1)
            sprintf(junk,"type the selected file via most Y/N [N]");
        else
            sprintf(junk,"type the %d selected files via most Y/N [N]",
                    files_selected);
        if (!confirm_user(junk,"Y"))
	{
	    sprintf(junk,"type the current file via most Y/N [N]");
	    if (!confirm_user(junk,"Y")) return(FALSE);
	    /*
	    **  most the current file
	    */
	    if (access(curr_file_ptr->filename,0) == 0)
	    {
		tmp = current_file_ptr(curr_file_no);
		most_args[num_most_args] = (char *) malloc(strlen(tmp->filename)+1);
		strcpy(most_args[num_most_args++],tmp->filename);
	    }
	    else
	    {
		sprintf(junk,"%s is not accessable",curr_file_ptr->filename);
		warning(junk);
		return(FALSE);
	    }
	}
	else
	{
        /*
        **  most the selected files
        */
        tmp = first_file_ptr;
        while(tmp)
        {
            if (tmp->rendition)
            {
                /*
                **  yup, this one's been chosen
                */
                if (access(tmp->filename,0) == 0)
                {
                most_args[num_most_args] =
                    (char *) malloc(strlen(tmp->filename)+1);
                strcpy(most_args[num_most_args++],tmp->filename);
                }
                else
                {
                sprintf(junk,"%s is not accessable",tmp->filename);
                warning(junk);
                }
            }
            tmp = tmp->forw_ptr;
        }
	}
    }

    /*
    **  if no files were accessible, return
    **  else do it
    */
    if (!num_most_args)
        return(FALSE);
    else
    {
        smg$save_physical_screen(&paste,&screen);
        disable_broadcasts();

            do_most_files(num_most_args,most_args);

        enable_broadcasts();
        smg$restore_physical_screen(&paste,&screen);
    }

    return(TRUE);
}

most_exception(sigarr, mecharr)
int *sigarr, *mecharr;
{
    /*
    **  unwind and return
    */
    lib$sig_to_ret(sigarr, mecharr);
    return(SS$_UNWIND);
}

do_most_files(num_most_args,most_args)
int num_most_args;
char *most_args[];
{
    VAXC$ESTABLISH(most_exception);
    most_less(num_most_args,most_args);
}
